/*
 * agent_ubus.h - wifi agent's ubus object header
 *
 * Copyright (C) 2019 IOPSYS Software Solutions AB. All rights reserved.
 *
 * Author: anjan.chanda@iopsys.eu
 *
 */

#ifndef AGENT_UBUS_H
#define AGENT_UBUS_H

/* wifi agent ubus objects */
//extern struct ubus_object wifiagent_object;

int agent_publish_object(struct agent *a, const char *objname);
void agent_remove_object(struct agent *a);
void agent_notify_event(struct agent *a, void *ev_type, void *ev_data);

/* Lower layer iface */
int wifi_ubus_scan_req(struct agent *a, const char *radio, const char *ssid);
int wifi_ubus_ap_set_state(struct agent *a, const char *name, bool up);
int wifi_ubus_sta_disconnect(struct agent *a, const char *name, const char *sta_macstr);
int wifi_ubus_sent_req_btm(struct agent *a, const char *name,
				  const char *client_macstr, uint8_t mode,
				  uint32_t disassoc_tmo, uint32_t bssterm_dur);
int wifi_ubus_opclass_preferences(struct agent *a, const char *radio,
				  struct wifi_opclass_supported_element *opclass,
				  int *num);
int wifi_ubus_start_cac(struct agent *agent, const char *radio, struct wifi_cac_entry *cac_entry);
int wifi_ubus_stop_cac(struct agent *agent, const char *radio);
int wifi_ubus_del_neighbor(struct agent *a, struct netif_fh *fh, uint8_t *bssid);
int wifi_ubus_add_neighbor(struct agent *a, struct netif_fh *fh, struct nbr *nbr);
int wifi_ubus_assoclist(struct agent *a, struct netif_fh *fh);
int wifi_ubus_radio_status(struct agent *a, const char *radio,
			   struct wifi_radio_element *radio_element);
int wifi_ubus_radio_scanresults(struct agent *a, const char *radio,
			   struct wifi_radio_element *radio_element);
#endif /* AGENT_UBUS_H */
